(in-package :asdf-world)

(defparameter *example-dir*
  (merge-pathnames (make-pathname :directory '(:relative "example"))
                   (make-pathname :name nil :type nil
                                  :defaults *load-truename*)))

(defparameter *example-worlds-dir*
  (merge-pathnames (make-pathname :directory '(:relative "worlds"))
                   *example-dir*))

(defparameter *example-install-dir*
  (merge-pathnames (make-pathname :directory '(:relative "site"))
                   *example-dir*))

(defparameter *example-world*
  (merge-pathnames (make-pathname :name "example" :type "world")
                   *example-worlds-dir*))

(format t "Worlds dir: ~A~%" *example-worlds-dir*)
(format t "Install dir: ~A~%" *example-install-dir*)

(ensure-directories-exist *example-worlds-dir*)
(ensure-directories-exist *example-install-dir*)

(create-world *example-world*)

(let ((asdf-world:*world* *example-world*))
  ;; oops, forgot to set INSTALL-LOCATION
  (setf (install-location) *example-install-dir*)
  (format t "Installing HELLO~%")
  (asdf-install:install
   (namestring (merge-pathnames "hello.tar.gz" *example-dir*)))
  ;; Install by hand a system from the file system. Truename makes sure
  ;; that we pass an absolute pathname that is turned into a pathname
  ;; relative to the world file.
  (setf (world-system-pathname :asdf-world)
        (truename
         (make-pathname
          :name "asdf-world" :type "asd"
          :defaults (merge-pathnames (make-pathname :directory '(:relative :up))
                                     *example-dir*))))
  ;; The world file looks like this at this point:
  ;;
  ;; (:INSTALL-LOCATION ((:UP "site") NIL NIL) :SYSTEM-MAP
  ;;  (("asdf-world" ((:UP :UP) "asdf-world" "asd"))
  ;;   ("hello" ((:UP "site" "salza-0.7.4") "salza" "asd"))))
  (format t "These are the installed systems in this world:~%")
  (map-world #'print))
