;;;; Beat ASDF and ASDF-INSTALL into submission.
;;;;
;;;; The purpose of this file is to make available all asdf libraries
;;;; under this directory through asdf and to tell asdf-install to
;;;; install packages here.

(in-package :asdf-install)

(defun select-location ()
  (loop with n-locations = (length *locations*)
        for response =
        (progn
          (format t "Install where?~%")
          (loop for (source system name) in *locations*
                for i from 1
                do (format t "~A) ~A: ~%   System in ~A~%   Files in ~A ~%"
                           i (eval name) (eval system) (eval source)))
          (format t "0) Abort installation.~% --> ")
          (force-output)
          (read))
        when (and (numberp response)
                  (<= 1 response n-locations))
        return response
        when (and (numberp response)
                  (zerop response))
        do (abort (make-condition 'installation-abort))))

(defun install-location ()
  (validate-preferred-location)
  (let ((location-selection (or *preferred-location*
				(select-location))))
    (etypecase location-selection
      (integer 
       (mapcar #'eval (elt *locations* (1- location-selection))))
      ((or symbol string)
       (find location-selection *locations* :key #'third
	     :test (if (typep location-selection 'string) 
                       #'string-equal #'eq))))))

;;; Hack ASDF-INSTALL into working with worlds instead of trying to
;;; create symlinks.
(defun maybe-symlink-sysfile (system sysfile)
  (cond ((equal system asdf-world:*world*)
         ;; We are installing into *WORLD*, write the list of
         ;; directories into the system list file.
         (setf (asdf-world:world-system-pathname (pathname-name sysfile))
               sysfile))
        (t
         #-(or :win32 :mswindows)
         (let ((target (merge-pathnames
                        (make-pathname :name (pathname-name sysfile)
                                       :type (pathname-type sysfile))
                        system)))
           (when (probe-file target)
             (unlink-file target))
           (symlink-files sysfile target)))))
