(in-package :asdf-install)

(defun where ()
  (format t "Install where?~%")
  (loop for (source system name) in *locations*
        for i from 1
        do (format t "~A) ~A: ~%   System in ~A~%   Files in ~A ~%"
                   i (eval name) (eval system) (eval source)))
  (format t " --> ") (force-output)
  (let ((response (read)))
    (when (> response 0)
      (mapcar #'eval (elt *locations* (1- response))))))


(defun install-package (source system packagename)
  "Returns a list of asdf system names for installed asdf systems"
  (ensure-directories-exist source)
  (ensure-directories-exist system)
  (let* ((tdir (get-tar-directory packagename))
         (*default-pathname-defaults*
          (merge-pathnames (make-pathname :directory `(:relative ,tdir))
                           source)))
    (princ (untar-package source packagename))
    (loop for asd in (directory
                      (make-pathname :name :wild :type "asd"))
          do (let ((target (merge-pathnames
                            (make-pathname :name (pathname-name asd)
                                           :type (pathname-type asd))
                            system)))
               (cond ((equal system asdf-world:*world*)
                      ;; We are installing into *WORLD*, write the
                      ;; list of directories into the system list
                      ;; file.
                      (setf (asdf-world:world-system-pathname
                             (pathname-name asd))
                            asd))
                     (t
                      (when (probe-file target)
                        (sb-posix:unlink target))
                      #-win32
                      (sb-posix:symlink asd target))))
          collect (pathname-name asd))))
